local a,L=... -- DO NOT REMOVE THIS LINE

local DCL=CreateFrame('frame',a)
local DCLPanel=CreateFrame('frame',a..'Panel')
local DCLUpdate=CreateFrame('frame',a..'Update')

Decliner_SV={}
local vars={
		duel={enabled,tell,guild,friend,bnet,message,},
		pet={enabled,tell,guild,friend,bnet,message,},
		guild={enabled,tell,friend,bnet,message,},
		group={enabled,tell,guild,friend,bnet,message,},
		chart={enabled,tell,guild,friend,bnet,message,},
		trade={enabled,tell,guild,friend,bnet,message,},
		dcl={messages,disable,},}
local defs={
	duel={enabled=true,tell=false,guild=false,friend=false,bnet=false,message=false,},
	pet={enabled=true,tell=false,guild=false,friend=false,bnet=false,message=false,},
	guild={enabled=true,tell=false,friend=false,bnet=false,message=false,},
	group={enabled=true,tell=false,guild=false,friend=false,bnet=false,message=false,},
	chart={enabled=true,tell=false,guild=false,friend=false,bnet=false,message=false,},
	trade={enabled=true,tell=false,guild=false,friend=false,bnet=false,message=false,},
	dcl={messages=false,disable=false,},}
local _StaticPopupDialogs,Ambiguate,checkboxnum,DCLDialog,format,gsub,msglist,namelist,next,notemp,pairs,random,strlower,strmatch,strupper,textnum,temp,tinsert,tremove,type=
{},Ambiguate,0,{},format,gsub,{},{},next,true,pairs,random,strlower,strmatch,strupper,0,{},tinsert,tremove,type

local _,action,addon,alpha,chatframe,checkbox,checkboxname,client,cti,dialog,duelerrormsg,duelreqmsg,frame,groupinvmsg,guild,guildinvmsg,justify,message,msgtimer,name,namerealm,notfound,oldSFX,OnHide,online,OnShow,originator,pattern,petduelmsg,peterrormsg,ptype,realm,settext,soundhandle,str,telltimer,text,textname,tooltip,tradeerrormsg,tradeinimsg,tradeinitiated,update,var,which,x,xloc,yloc

function DCL:Pattern(pattern)
	pattern=gsub(pattern,'|Hpatternlayer:','')
	pattern=gsub(pattern,'%%%d?$?c','')
	pattern=gsub(pattern,'%%%d?$?d','')
	pattern=gsub(pattern,'%%%d?$?s','')
	pattern=gsub(pattern,'%[.*%]','')
	pattern=gsub(pattern,':.*','')
	pattern=gsub(pattern,'|h','')
	pattern=gsub(pattern,'%.','')
	pattern=gsub(pattern,'^%s','')
	pattern=gsub(pattern,'%s$','')
	return pattern
end

duelerrormsg='.*'..DCL:Pattern(ERR_DUEL_CANCELLED)..'.*'
peterrormsg='.*'..DCL:Pattern(ERR_PETBATTLE_DECLINED)..'.*'
tradeerrormsg='.*'..DCL:Pattern(ERR_TRADE_CANCELLED)..'.*'
tradeinimsg='.*'..DCL:Pattern(ERR_INITIATE_TRADE_S)..'.*'
duelreqmsg='.*'..DCL:Pattern(DUEL_REQUESTED)..'.*'
petduelmsg='.*'..DCL:Pattern(PET_BATTLE_PVP_DUEL_REQUESTED)..'.*'
guildinvmsg='.*'..DCL:Pattern(ERR_INVITED_TO_GUILD_SSS)..'.*'
groupinvmsg='.*'..DCL:Pattern(ERR_INVITED_TO_GROUP_SS)..'.*'

function DCL:IsAllowed(namerealm,var)
	if vars.dcl.disable or not vars[var].enabled then return true end
	if next(namelist) ~= nil then
		for k,v in pairs(namelist) do
			if not vars[var].tell and v == namerealm then return true end
		end
	end
	if var ~= 'guild' then
		if not vars[var].guild and IsInGuild() then
			for i=1,(GetNumGuildMembers()) do
				if namerealm == Ambiguate((GetGuildRosterInfo(i)),'mail') then return true end
			end
		end
	end
	if not vars[var].friend then
		for i=1,(GetNumFriends()) do
			if namerealm == Ambiguate((GetFriendInfo(i)),'mail') then return true end
		end
	end
	if not vars[var].bnet then
		for i=1,(BNGetNumFriends()) do
			_,_,_,_,_,_,client,online=BNGetFriendInfo(i)
			if online and client == 'WoW' then
				for j=1,(BNGetNumFriendToons(i)) do
					_,name,_,realm=BNGetFriendToonInfo(i,j)
					if namerealm == name..'-'..realm then return true end
				end
			end
		end
	end
	return false
end

function DCL:Timer(str)
	if str == 'msg' then
		msgtimer=true
		C_Timer.After(60,function()
			tremove(msglist,1)
			if next(msglist) ~= nil then
				DCL:Timer('msg')
			else
				msgtimer=false
			end
		end)
	elseif str == 'tell' then
		telltimer=true
		C_Timer.After(60,function()
			tremove(namelist,1)
			if next(namelist) ~= nil then
				DCL:Timer('tell')
			else
				telltimer=false
			end
		end)
	end
end

function DCL:Print(message)
	if vars.dcl.messages then return end
	if next(msglist) ~= nil then
		for k,v in pairs(msglist) do
			if v == message then return end
		end
	end
	tinsert(msglist,message)
	if not msgtimer then DCL:Timer('msg') end
	cti,notfound=ChatTypeInfo['SYSTEM'],true
	for i=1,NUM_CHAT_WINDOWS do
		chatframe=_G['ChatFrame'..i]
		if chatframe:IsEventRegistered('CHAT_MSG_SYSTEM') then notfound=false
			chatframe:AddMessage('|cffff0000'..a..': |r'..message..'',cti.r,cti.g,cti.b,cti.id)
		end
	end
	if notfound then
		DEFAULT_CHAT_FRAME:AddMessage('|cffff0000'..a..': |r'..message..'',cti.r,cti.g,cti.b,cti.id)
	end
end

function DCL:ADDON_LOADED(addon)
	if addon ~= a then return end
	_StaticPopupDialogs['DUEL_REQUESTED']=StaticPopupDialogs['DUEL_REQUESTED']
	_StaticPopupDialogs['PET_BATTLE_PVP_DUEL_REQUESTED']=StaticPopupDialogs['PET_BATTLE_PVP_DUEL_REQUESTED']
	_StaticPopupDialogs['PARTY_INVITE']=StaticPopupDialogs['PARTY_INVITE']
	_StaticPopupDialogs['PARTY_INVITE_XREALM']=StaticPopupDialogs['PARTY_INVITE_XREALM']
	if Decliner_SV.saved then
		for k1,v1 in pairs(defs) do
			if Decliner_SV[k1] == nil then
				Decliner_SV[k1]=defs[k1]
			end
			for k2,v2 in pairs(v1) do
				if Decliner_SV[k1][k2] == nil then
					Decliner_SV[k1][k2]=defs[k1][k2]
				elseif type(Decliner_SV[k1][k2]) ~= 'boolean' then
					Decliner_SV[k1][k2]=defs[k1][k2]
				end
			end
		end
		vars=DCL:DeepCopy(Decliner_SV)
		Decliner_SV.saved=true
	else
		vars=DCL:DeepCopy(defs)
		Decliner_SV=DCL:DeepCopy(defs)
		Decliner_SV.saved=true
	end
	GuildRoster()
	ShowFriends()
	DCL:Options()
	DCL:MainEventReg()
	DCL:BlizzardGT()
	oldSFX=GetCVar('Sound_EnableSFX')
	DCL:Print(''..strlower(GAME_VERSION_LABEL)..' '..GetAddOnMetadata(a,'Version')..' '..strlower(READY)..'')
	DCL:UnregisterEvent('ADDON_LOADED')
end

function DCL:CHAT_MSG_WHISPER_INFORM(_,name)
	tinsert(namelist,Ambiguate(name,'mail'))
	if not telltimer then DCL:Timer('tell') end
end

function DCL:CVAR_UPDATE(cvar,value)
	oldSFX=GetCVar('Sound_EnableSFX')
	if cvar == 'BLOCK_TRADES' and value == '0' and not vars.trade.enabled then
		vars.trade.enabled=true
		DCL:Print(L['BLOCK_TRADES_OFF'])
	elseif cvar == 'BLOCK_TRADES' and value == '1' and vars.trade.enabled then
		vars.trade.enabled=false
		DCL:Print(L['BLOCK_TRADES_ON'])
	end
end

function DCL:DISABLE_DECLINE_GUILD_INVITE()
	if vars.guild.enabled then return end
	vars.guild.enabled=true
	DCL:Print(L['BLOCK_GUILDS_OFF'])
end

function DCL:ENABLE_DECLINE_GUILD_INVITE()
	if not vars.guild.enabled then return end
	vars.guild.enabled=false
	DCL:Print(L['BLOCK_GUILDS_ON'])
end

function DCL:DUEL_REQUESTED(name)
	_,frame=StaticPopup_Visible('DUEL_REQUESTED')
	HideUIPanel(frame)
	namerealm=Ambiguate(name,'mail')
	if DCL:IsAllowed(namerealm,'duel') then
		DCL:SetStaticPopup(frame,'default')
		ShowUIPanel(frame)
		PlaySoundKitID(880)
	else
		CancelDuel()
		name=Ambiguate(name,'none')
		if not vars.duel.message then
			DCL:Print(format(L['DUEL_DECLINED'],'|Hplayer:'..name..'|h['..name..']|h'))
		end
	end
end

function DCL:PET_BATTLE_PVP_DUEL_REQUESTED(name)
	_,frame=StaticPopup_Visible('PET_BATTLE_PVP_DUEL_REQUESTED')
	HideUIPanel(frame)
	namerealm=Ambiguate(name,'mail')
	if DCL:IsAllowed(namerealm,'pet') then
		DCL:SetStaticPopup(frame,'default')
		ShowUIPanel(frame)
		PlaySoundKitID(880)
	else
		C_PetBattles.CancelPVPDuel()
		name=Ambiguate(name,'none')
		if not vars.pet.message then
			DCL:Print(format(L['PET_DECLINED'],'|Hplayer:'..name..'|h['..name..']|h'))
		end
	end
end

function DCL:GUILD_INVITE_REQUEST(name,guild)
	SetCVar('Sound_EnableSFX','0')
	namerealm=Ambiguate(name,'mail')
	if DCL:IsAllowed(namerealm,'guild') then
		C_Timer.After(0.5,function()
			SetCVar('Sound_EnableSFX',oldSFX)
			PlaySoundKidID(888)
		end)
	else
		StaticPopupSpecial_Hide(GuildInviteFrame)
		DeclineGuild()
		name=Ambiguate(name,'none')
		if not vars.guild.message then
			DCL:Print(format(L['GUILD_DECLINED'],'|Hplayer:'..name..'|h['..name..']|h',guild))
		end
		C_Timer.After(0.5,function() SetCVar('Sound_EnableSFX',oldSFX) end)
	end
end

function DCL:PARTY_INVITE_REQUEST(name)
	_,frame=StaticPopup_Visible('PARTY_INVITE') which='PARTY_INVITE'
	if not frame then
		_,frame=StaticPopup_Visible('PARTY_INVITE_XREALM') which='PARTY_INVITE_XREALM'
	end
	HideUIPanel(frame)
	namerealm=Ambiguate(name,'mail')
	if DCL:IsAllowed(namerealm,'group') then
		DCL:SetStaticPopup(frame,'default')
		ShowUIPanel(frame)
		PlaySoundKitID(880)
		StaticPopupDialogs[which].OnHide=function(self)
			if not self.inviteAccepted then
				DeclineGroup()
				self:Hide()
			end
			StaticPopupDialogs[which]=DCLDialog[which]
		end
	else
		DeclineGroup()
		name=Ambiguate(name,'none')
		if not vars.group.message then
			DCL:Print(format(L['GROUP_DECLINED'],'|Hplayer:'..name..'|h['..name..']|h'))
		end
	end
end

function DCL:PETITION_SHOW()
	HideUIPanel(PetitionFrame)
	ptype,_,_,_,name,originator=GetPetitionInfo()
	namerealm=Ambiguate(name,'mail')
	if originator or DCL:IsAllowed(namerealm,'chart') then
		DCL:SetPetitionFrame('default')
		ShowUIPanel(PetitionFrame)
	else
		ClosePetition()
		name=Ambiguate(name,'none')
		if not vars.chart.message then
			if ptype == 'arena' then
				DCL:Print(format(L['CHART_DECLINED_ARENA'],'|Hplayer:'..name..'|h['..name..']|h'))
			elseif ptype == 'guild' then
				DCL:Print(format(L['CHART_DECLINED_GUILD'],'|Hplayer:'..name..'|h['..name..']|h'))
			else DCL:Print(format(L['CHART_DECLINED_NIL'],'|Hplayer:'..name..'|h['..name..']|h'))
			end
		end
	end
end

function DCL:TRADE_SHOW()
	HideUIPanel(TradeFrame)
	name,realm=UnitName('npc')
	if not realm then
		namerealm=Ambiguate(name,'mail')
	else
		namerealm=name..'-'..realm
	end
	if tradeinitiated or DCL:IsAllowed(namerealm,'chart') then
		DCL:SetTradeFrame('default')
		ShowUIPanel(TradeFrame)
	else
		CloseTrade()
		name=Ambiguate(name,'none')
		if not vars.trade.message then
			DCL:Print(format(L['TRADE_DECLINED'],'|Hplayer:'..name..'|h['..name..']|h'))
		end
	end
end

function DCL:TRADE_CLOSED()
	tradeinitiated=false
end

function DCL:UI_INFO_MESSAGE(message)
	if vars.dcl.disable then return end
	if strmatch(message,duelerrormsg) and not DCL:IsAllowed(namerealm,'duel') then UIErrorsFrame:Clear() end
	if strmatch(message,peterrormsg) and not DCL:IsAllowed(namerealm,'pet') then UIErrorsFrame:Clear() end
	if strmatch(message,tradeerrormsg) and not DCL:IsAllowed(namerealm,'trade') then UIErrorsFrame:Clear() end
end

DCL:RegisterEvent('ADDON_LOADED')
DCL:RegisterEvent('CHAT_MSG_WHISPER_INFORM')
DCL:RegisterEvent('CVAR_UPDATE')
DCL:RegisterEvent('DISABLE_DECLINE_GUILD_INVITE')
DCL:RegisterEvent('ENABLE_DECLINE_GUILD_INVITE')
DCL:SetScript('OnEvent',function(self,event,...) self[event](self,...) end)

ChatFrame_AddMessageEventFilter('CHAT_MSG_SYSTEM',function(_,_,message)
	if vars.dcl.disable then return false end
	if strmatch(message,tradeinimsg) then tradeinitiated=true end
	if strmatch(message,duelreqmsg) and not DCL:IsAllowed(namerealm,'duel') then return true end
	if strmatch(message,petduelmsg) and not DCL:IsAllowed(namerealm,'pet') then return true end
	if strmatch(message,guildinvmsg) and not DCL:IsAllowed(namerealm,'guild') then return true end
	if strmatch(message,groupinvmsg) and not DCL:IsAllowed(namerealm,'group') then return true end
	return false
end)

DCLDialog['DUEL_REQUESTED']={
	text=DUEL_REQUESTED,
	button1=ACCEPT,
	button2=DECLINE,
	OnAccept=function(self)
		AcceptDuel()
	end,
	OnCancel=function(self)
		CancelDuel()
	end,
	timeout=STATICPOPUP_TIMEOUT,
	hideOnEscape=1
}

DCLDialog['PET_BATTLE_PVP_DUEL_REQUESTED']={
	text=PET_BATTLE_PVP_DUEL_REQUESTED,
	button1=ACCEPT,
	button2=DECLINE,
	OnAccept=function(self)
		C_PetBattles.AcceptPVPDuel()
	end,
	OnCancel=function(self)
		C_PetBattles.CancelPVPDuel()
	end,
	timeout=STATICPOPUP_TIMEOUT,
	hideOnEscape=1
}

DCLDialog['PARTY_INVITE']={
	text=INVITATION,
	button1=ACCEPT,
	button2=DECLINE,
	OnShow=function(self)
		self.inviteAccepted=nil
	end,
	OnAccept=function(self)
		AcceptGroup()
		self.inviteAccepted=1
	end,
	OnCancel=function(self)
		DeclineGroup()
	end,
	OnHide=function(self)
		if (not self.inviteAccepted) then
			self:Hide()
		end
	end,
	timeout=STATICPOPUP_TIMEOUT,
	whileDead=1,
	hideOnEscape=1
}

DCLDialog['PARTY_INVITE_XREALM']={
	text=INVITATION_XREALM,
	button1=ACCEPT,
	button2=DECLINE,
	OnShow=function(self)
		self.inviteAccepted=nil
	end,
	OnAccept=function(self)
		AcceptGroup()
		self.inviteAccepted=1
	end,
	OnCancel=function(self)
		DeclineGroup()
	end,
	OnHide=function(self)
		if (not self.inviteAccepted) then
			self:Hide()
		end
	end,
	timeout=STATICPOPUP_TIMEOUT,
	whileDead=1,
	hideOnEscape=1
}

local DCLDialog_OnShow=function(frame)
	dialog=frame.which
	if dialog and
	((dialog == 'DUEL_REQUESTED' and vars.duel.enabled) or
	(dialog == 'PET_BATTLE_PVP_DUEL_REQUESTED' and vars.pet.enabled) or
	((dialog == 'PARTY_INVITE' or dialog == 'PARTY_INVITE_XREALM') and vars.group.enabled)) then
		OnShow=dialog.OnShow
		if (OnShow) then
			OnShow(frame,frame.data)
		end
		if (dialog.enterClicksFirstButton) then
			frame:SetScript('OnKeyDown',StaticPopup_OnKeyDown)
		end
	else
		StaticPopup_OnShow(frame)
	end
end

local DCLDialog_OnHide=function(frame)
	dialog=frame.which
	if dialog and
	((dialog == 'DUEL_REQUESTED' and vars.duel.enabled) or
	(dialog == 'PET_BATTLE_PVP_DUEL_REQUESTED' and vars.pet.enabled) or
	((dialog == 'PARTY_INVITE' or dialog == 'PARTY_INVITE_XREALM') and vars.group.enabled)) then
		StaticPopup_CollapseTable()
		OnHide=dialog.OnHide
		if (OnHide) then
			OnHide(frame,frame.data)
		end
		if (dialog.enterClicksFirstButton) then
			frame:SetScript('OnKeyDown',nil)
		end
	else
		StaticPopup_OnHide(frame)
	end
end

function DCL:SetStaticPopup(frame,action)
	frame:SetScript('OnShow',nil)
	frame:SetScript('OnHide',nil)
	if action == 'decline' then
		frame:SetScript('OnShow',function()
			DCLDialog_OnShow(frame)
		end)
		frame:SetScript('OnHide',function()
			DCLDialog_OnHide(frame)
		end)
	elseif action == 'default' and vars.dcl.disable then
		frame:SetScript('OnShow',function()
			StaticPopup_OnShow(frame)
		end)
		frame:SetScript('OnHide',function()
			StaticPopup_OnHide(frame)
		end)
	elseif action == 'default' then
		frame:SetScript('OnShow',function()
			StaticPopup_OnShow(frame)
		end)
		frame:SetScript('OnHide',function()
			StaticPopup_OnHide(frame)
			if vars.duel.enabled or vars.pet.enabled or vars.group.enabled then
				DCL:SetStaticPopup(frame,'decline')
			end
		end)
	end
end

function DCL:SetPetitionFrame(action)
	PetitionFrame:SetScript('OnShow',nil)
	PetitionFrame:SetScript('OnHide',nil)
	if action == 'decline' then
		PetitionFrame:SetScript('OnHide',function()
			StaticPopup_Hide('CONFIRM_GUILD_CHARTER_SIGNATURE')
		end)
	elseif action == 'default' and vars.dcl.disable then
		PetitionFrame:SetScript('OnShow',function()
			PlaySoundKitID(875)
		end)
		PetitionFrame:SetScript('OnHide',function()
			PlaySoundKitID(876)
			StaticPopup_Hide('CONFIRM_GUILD_CHARTER_SIGNATURE')
			ClosePetition()
		end)
	elseif action == 'default' then
		PetitionFrame:SetScript('OnShow',function()
			PlaySoundKitID(875)
		end)
		PetitionFrame:SetScript('OnHide',function()
			PlaySoundKitID(876)
			StaticPopup_Hide('CONFIRM_GUILD_CHARTER_SIGNATURE')
			ClosePetition()
			if vars.chart.enabled then DCL:SetPetitionFrame('decline') end
		end)
	end
end

function DCL:SetTradeFrame(action)
	TradeFrame:SetScript('OnShow',nil)
	TradeFrame:SetScript('OnHide',nil)
	if action == 'decline' then
		TradeFrame:SetScript('OnShow',function()
			TradeFrame_OnShow(self)
		end)
		TradeFrame:SetScript('OnHide',function()
			MoneyInputFrame_SetCopper(TradePlayerInputMoneyFrame,0)
		end)
	elseif action == 'default' and vars.dcl.disable then
		TradeFrame:SetScript('OnShow',function()
			TradeFrame_OnShow(self)
			PlaySoundKitID(839)
		end)
		TradeFrame:SetScript('OnHide',function()
			TradeFrame_OnHide()
			PlaySoundKitID(840)
		end)
	elseif action == 'default' then
		TradeFrame:SetScript('OnShow',function()
			TradeFrame_OnShow(self)
			PlaySoundKitID(839)
		end)
		TradeFrame:SetScript('OnHide',function()
			TradeFrame_OnHide()
			PlaySoundKitID(840)
			if vars.trade.enabled then DCL:SetTradeFrame('decline') end
		end)
	end
end

function DCL:MainEventReg()
	if vars.dcl.disable then
		DCL:UnregisterAllEvents()
		StaticPopupDialogs['DUEL_REQUESTED']=_StaticPopupDialogs['DUEL_REQUESTED']
		StaticPopupDialogs['PET_BATTLE_PVP_DUEL_REQUESTED']=_StaticPopupDialogs['PET_BATTLE_PVP_DUEL_REQUESTED']
		StaticPopupDialogs['PARTY_INVITE']=_StaticPopupDialogs['PARTY_INVITE']
		StaticPopupDialogs['PARTY_INVITE_XREALM']=_StaticPopupDialogs['PARTY_INVITE_XREALM']
		DCL:SetPetitionFrame('default')
		DCL:SetTradeFrame('default')
		for i=1,STATICPOPUP_NUMDIALOGS do
			frame=_G['StaticPopup'..i]
			DCL:SetStaticPopup(frame,'default')
		end
	else
		if not DCL:IsEventRegistered('CHAT_MSG_WHISPER_INFORM') then DCL:RegisterEvent('CHAT_MSG_WHISPER_INFORM') end
		if not DCL:IsEventRegistered('CVAR_UPDATE') then DCL:RegisterEvent('CVAR_UPDATE') end
		if not DCL:IsEventRegistered('DISABLE_DECLINE_GUILD_INVITE') then DCL:RegisterEvent('DISABLE_DECLINE_GUILD_INVITE') end
		if not DCL:IsEventRegistered('ENABLE_DECLINE_GUILD_INVITE') then DCL:RegisterEvent('ENABLE_DECLINE_GUILD_INVITE') end
		if vars.duel.enabled then
			DCL:RegisterEvent('DUEL_REQUESTED')
			StaticPopupDialogs['DUEL_REQUESTED']=DCLDialog['DUEL_REQUESTED']
		else
			DCL:UnregisterEvent('DUEL_REQUESTED')
			StaticPopupDialogs['DUEL_REQUESTED']=_StaticPopupDialogs['DUEL_REQUESTED']
		end
		if vars.pet.enabled then
			DCL:RegisterEvent('PET_BATTLE_PVP_DUEL_REQUESTED')
			StaticPopupDialogs['PET_BATTLE_PVP_DUEL_REQUESTED']=DCLDialog['PET_BATTLE_PVP_DUEL_REQUESTED']
		else
			DCL:UnregisterEvent('PET_BATTLE_PVP_DUEL_REQUESTED')
			StaticPopupDialogs['PET_BATTLE_PVP_DUEL_REQUESTED']=_StaticPopupDialogs['PET_BATTLE_PVP_DUEL_REQUESTED']
		end
		if vars.guild.enabled then
			DCL:RegisterEvent('GUILD_INVITE_REQUEST')
		else
			DCL:UnregisterEvent('GUILD_INVITE_REQUEST')
		end
		if vars.group.enabled then
			DCL:RegisterEvent('PARTY_INVITE_REQUEST')
			StaticPopupDialogs['PARTY_INVITE']=DCLDialog['PARTY_INVITE']
			StaticPopupDialogs['PARTY_INVITE_XREALM']=DCLDialog['PARTY_INVITE_XREALM']
		else
			DCL:UnregisterEvent('PARTY_INVITE_REQUEST')
			StaticPopupDialogs['PARTY_INVITE']=_StaticPopupDialogs['PARTY_INVITE']
			StaticPopupDialogs['PARTY_INVITE_XREALM']=_StaticPopupDialogs['PARTY_INVITE_XREALM']
		end
		if vars.chart.enabled then
			DCL:RegisterEvent('PETITION_SHOW')
			DCL:SetPetitionFrame('decline')
		else
			DCL:UnregisterEvent('PETITION_SHOW')
			DCL:SetPetitionFrame('default')
		end
		if vars.trade.enabled then
			DCL:RegisterEvent('TRADE_SHOW')
			DCL:RegisterEvent('TRADE_CLOSED')
			DCL:SetTradeFrame('decline')
		else
			DCL:UnregisterEvent('TRADE_SHOW')
			DCL:UnregisterEvent('TRADE_CLOSED')
			DCL:SetTradeFrame('default')
		end
		if vars.duel.enabled or vars.pet.enabled or vars.group.enabled then
			for i=1,STATICPOPUP_NUMDIALOGS do
				frame=_G['StaticPopup'..i]
				DCL:SetStaticPopup(frame,'decline')
			end
		else
			for i=1,STATICPOPUP_NUMDIALOGS do
				frame=_G['StaticPopup'..i]
				DCL:SetStaticPopup(frame,'default')
			end
		end
		if vars.duel.enabled or vars.pet.enabled or vars.trade.enabled then
			DCL:RegisterEvent('UI_INFO_MESSAGE')
		else
			DCL:UnregisterEvent('UI_INFO_MESSAGE')
		end
	end
end

function DCL:BlizzardGT()
	if vars.guild.enabled and not vars.dcl.disable then
		_G['InterfaceOptionsControlsPanelBlockGuildInvitesText']:SetText('|cff666666'..BLOCK_GUILD_INVITES..' (Decliner)')
		_G['InterfaceOptionsControlsPanelBlockGuildInvites']:Disable()
		_G['InterfaceOptionsControlsPanelBlockGuildInvites']:SetChecked(false)
	else
		_G['InterfaceOptionsControlsPanelBlockGuildInvitesText']:SetText(BLOCK_GUILD_INVITES)
		_G['InterfaceOptionsControlsPanelBlockGuildInvites']:Enable()
	end
	if vars.trade.enabled and not vars.dcl.disable then
		_G['InterfaceOptionsControlsPanelBlockTradesText']:SetText('|cff666666'..BLOCK_TRADES..' (Decliner)')
		_G['InterfaceOptionsControlsPanelBlockTrades']:Disable()
		_G['InterfaceOptionsControlsPanelBlockTrades']:SetChecked(false)
	else
		_G['InterfaceOptionsControlsPanelBlockTradesText']:SetText(BLOCK_TRADES)
		_G['InterfaceOptionsControlsPanelBlockTrades']:Enable()
	end
end

function DCL:CreateText(xloc,yloc,justify,text)
	textnum=textnum+1
	textname=a..'TextGlobal'..format('%02i',textnum)
	settext=DCLPanel:CreateFontString(textname,'ARTWORK','GameFontNormalSmall')
	settext:SetPoint(justify,DCLPanel,'TOPLEFT',xloc,yloc)
	settext:SetText(text)
	return settext
end

function DCL:CreateCheckBox(xloc,yloc,tooltip,text)
	checkboxnum=checkboxnum+1
	checkboxname=a..'CheckBoxGlobal'..format('%02i',checkboxnum)
	checkbox=CreateFrame('CheckButton',checkboxname,DCLPanel,'InterfaceOptionsCheckButtonTemplate')
	checkbox:SetPoint('CENTER',DCLPanel,'TOPLEFT',xloc,yloc)
	checkbox:SetHitRectInsets(0,0,0,0)
	checkbox.tooltipText=tooltip
	_G[checkboxname..'Text']:SetText('|cffffd100'..text)
	return checkbox
end

function DCL:Options()
	DCLPanel.name=a
	InterfaceOptions_AddCategory(DCLPanel,a)
	DCLText01=DCL:CreateText(144,-32,'CENTER',DUEL)
	DCLText02=DCL:CreateText(144,-48,'CENTER',GUILDINFOTAB_APPLICANTS_NONE)
	DCLText03=DCL:CreateText(208,-32,'CENTER',PET_BATTLE_PVP_DUEL)
	DCLText04=DCL:CreateText(208,-48,'CENTER',GUILDINFOTAB_APPLICANTS_NONE)
	DCLText05=DCL:CreateText(272,-32,'CENTER',GUILD)
	DCLText06=DCL:CreateText(272,-48,'CENTER',DCL:Pattern(GUILDEVENT_TYPE_INVITE))
	DCLText07=DCL:CreateText(336,-32,'CENTER',GROUP)
	DCLText08=DCL:CreateText(336,-48,'CENTER',DCL:Pattern(GUILDEVENT_TYPE_INVITE))
	DCLText09=DCL:CreateText(400,-32,'CENTER',ARENA..'/'..GUILD)
	DCLText10=DCL:CreateText(400,-48,'CENTER',DCL:Pattern(PETITION_TITLE))
	DCLText11=DCL:CreateText(464,-32,'CENTER',TRADE)
	DCLText12=DCL:CreateText(464,-48,'CENTER',GUILDINFOTAB_APPLICANTS_NONE)
	DCLText13=DCL:CreateText(8,-80,'LEFT',ENABLE..' '..DECLINE)
	DCLCheckBox01=DCL:CreateCheckBox(144,-80,'|cff00ff00'..L['DUEL_ENABLE'],'')
	DCLCheckBox02=DCL:CreateCheckBox(208,-80,'|cff00ff00'..L['PET_ENABLE'],'')
	DCLCheckBox03=DCL:CreateCheckBox(272,-80,'|cff00ff00'..L['GUILD_ENABLE'],'')
	DCLCheckBox04=DCL:CreateCheckBox(336,-80,'|cff00ff00'..L['GROUP_ENABLE'],'')
	DCLCheckBox05=DCL:CreateCheckBox(400,-80,'|cff00ff00'..L['CHART_ENABLE'],'')
	DCLCheckBox06=DCL:CreateCheckBox(464,-80,'|cff00ff00'..L['TRADE_ENABLE'],'')
	DCLText14=DCL:CreateText(8,-144,'LEFT',L['TELL_TITLE'])
	DCLCheckBox07=DCL:CreateCheckBox(144,-144,'|cffff0000'..L['DUEL_TELL'],'')
	DCLCheckBox08=DCL:CreateCheckBox(208,-144,'|cffff0000'..L['PET_TELL'],'')
	DCLCheckBox09=DCL:CreateCheckBox(272,-144,'|cffff0000'..L['GUILD_TELL'],'')
	DCLCheckBox10=DCL:CreateCheckBox(336,-144,'|cffff0000'..L['GROUP_TELL'],'')
	DCLCheckBox11=DCL:CreateCheckBox(400,-144,'|cffff0000'..L['CHART_TELL'],'')
	DCLCheckBox12=DCL:CreateCheckBox(464,-144,'|cffff0000'..L['TRADE_TELL'],'')
	DCLText15=DCL:CreateText(8,-208,'LEFT',DCL:Pattern(INSPECT_GUILD_NUM_MEMBERS))
	DCLCheckBox13=DCL:CreateCheckBox(144,-208,'|cffff0000'..L['DUEL_GUILD'],'')
	DCLCheckBox14=DCL:CreateCheckBox(208,-208,'|cffff0000'..L['PET_GUILD'],'')
	DCLCheckBox15=DCL:CreateCheckBox(272,-208,'|cffff0000'..L['GUILD_GUILD'],'')
	DCLCheckBox16=DCL:CreateCheckBox(336,-208,'|cffff0000'..L['GROUP_GUILD'],'')
	DCLCheckBox17=DCL:CreateCheckBox(400,-208,'|cffff0000'..L['CHART_GUILD'],'')
	DCLCheckBox18=DCL:CreateCheckBox(464,-208,'|cffff0000'..L['TRADE_GUILD'],'')
	DCLText16=DCL:CreateText(8,-272,'LEFT',DCL:Pattern(FRIENDS_LIST_REALM)..' '..FRIENDS)
	DCLCheckBox19=DCL:CreateCheckBox(144,-272,'|cffff0000'..L['DUEL_FRIEND'],'')
	DCLCheckBox20=DCL:CreateCheckBox(208,-272,'|cffff0000'..L['PET_FRIEND'],'')
	DCLCheckBox21=DCL:CreateCheckBox(272,-272,'|cffff0000'..L['GUILD_FRIEND'],'')
	DCLCheckBox22=DCL:CreateCheckBox(336,-272,'|cffff0000'..L['GROUP_FRIEND'],'')
	DCLCheckBox23=DCL:CreateCheckBox(400,-272,'|cffff0000'..L['CHART_FRIEND'],'')
	DCLCheckBox24=DCL:CreateCheckBox(464,-272,'|cffff0000'..L['TRADE_FRIEND'],'')
	DCLText17=DCL:CreateText(8,-336,'LEFT',REAL_ID..'/'..BATTLETAG)
	DCLCheckBox25=DCL:CreateCheckBox(144,-336,'|cffff0000'..L['DUEL_BNET'],'')
	DCLCheckBox26=DCL:CreateCheckBox(208,-336,'|cffff0000'..L['PET_BNET'],'')
	DCLCheckBox27=DCL:CreateCheckBox(272,-336,'|cffff0000'..L['GUILD_BNET'],'')
	DCLCheckBox28=DCL:CreateCheckBox(336,-336,'|cffff0000'..L['GROUP_BNET'],'')
	DCLCheckBox29=DCL:CreateCheckBox(400,-336,'|cffff0000'..L['CHART_BNET'],'')
	DCLCheckBox30=DCL:CreateCheckBox(464,-336,'|cffff0000'..L['TRADE_BNET'],'')
	DCLText18=DCL:CreateText(8,-400,'LEFT',SYSTEM_MESSAGES)
	DCLCheckBox31=DCL:CreateCheckBox(144,-400,'|cffff0000'..HIDE..' \''..a..':'..DUEL..'\' '..SYSTEM_MESSAGES,'')
	DCLCheckBox32=DCL:CreateCheckBox(208,-400,'|cffff0000'..HIDE..' \''..a..':'..PET_BATTLE_PVP_DUEL..'\' '..SYSTEM_MESSAGES,'')
	DCLCheckBox33=DCL:CreateCheckBox(272,-400,'|cffff0000'..HIDE..' \''..a..':'..GUILD..'\' '..SYSTEM_MESSAGES,'')
	DCLCheckBox34=DCL:CreateCheckBox(336,-400,'|cffff0000'..HIDE..' \''..a..':'..GROUP..'\' '..SYSTEM_MESSAGES,'')
	DCLCheckBox35=DCL:CreateCheckBox(400,-400,'|cffff0000'..HIDE..' \''..a..':'..DCL:Pattern(PETITION_TITLE)..'\' '..SYSTEM_MESSAGES,'')
	DCLCheckBox36=DCL:CreateCheckBox(464,-400,'|cffff0000'..HIDE..' \''..a..':'..TRADE..'\' '..SYSTEM_MESSAGES,'')
	DCLCheckBox37=DCL:CreateCheckBox(144,-464,'|cffff0000'..L['DISABLE_MESSAGES'],DISABLE..' '..strupper(ALL)..' '..a..' '..SYSTEM_MESSAGES)
	DCLCheckBox38=DCL:CreateCheckBox(144,-496,'|cffff0000'..L['MAIN_DISABLE'],DISABLE..' '..a)
	DCLCheckBox01:SetScript('PostClick',function()vars.duel.enabled=DCLCheckBox01:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox02:SetScript('PostClick',function()vars.pet.enabled=DCLCheckBox02:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox03:SetScript('PostClick',function()vars.guild.enabled=DCLCheckBox03:GetChecked()DCLUpdate:Print()DCL:BlizzardGT()end)
	DCLCheckBox04:SetScript('PostClick',function()vars.group.enabled=DCLCheckBox04:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox05:SetScript('PostClick',function()vars.chart.enabled=DCLCheckBox05:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox06:SetScript('PostClick',function()vars.trade.enabled=DCLCheckBox06:GetChecked()DCLUpdate:Print()DCL:BlizzardGT()end)
	DCLCheckBox07:SetScript('PostClick',function()vars.duel.tell=DCLCheckBox07:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox08:SetScript('PostClick',function()vars.pet.tell=DCLCheckBox08:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox09:SetScript('PostClick',function()vars.guild.tell=DCLCheckBox09:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox10:SetScript('PostClick',function()vars.group.tell=DCLCheckBox10:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox11:SetScript('PostClick',function()vars.chart.tell=DCLCheckBox11:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox12:SetScript('PostClick',function()vars.trade.tell=DCLCheckBox12:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox13:SetScript('PostClick',function()vars.duel.guild=DCLCheckBox13:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox14:SetScript('PostClick',function()vars.pet.guild=DCLCheckBox14:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox15:SetScript('PostClick',function()if soundhandle then StopSound(soundhandle)end x=random(1,51000)_,soundhandle=PlaySoundKitID(x)DCLCheckBox15:SetChecked(false)end)
	DCLCheckBox16:SetScript('PostClick',function()vars.group.guild=DCLCheckBox16:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox17:SetScript('PostClick',function()vars.chart.guild=DCLCheckBox17:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox18:SetScript('PostClick',function()vars.trade.guild=DCLCheckBox18:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox19:SetScript('PostClick',function()vars.duel.friend=DCLCheckBox19:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox20:SetScript('PostClick',function()vars.pet.friend=DCLCheckBox20:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox21:SetScript('PostClick',function()vars.guild.friend=DCLCheckBox21:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox22:SetScript('PostClick',function()vars.group.friend=DCLCheckBox22:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox23:SetScript('PostClick',function()vars.chart.friend=DCLCheckBox23:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox24:SetScript('PostClick',function()vars.trade.friend=DCLCheckBox24:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox25:SetScript('PostClick',function()vars.duel.bnet=DCLCheckBox25:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox26:SetScript('PostClick',function()vars.pet.bnet=DCLCheckBox26:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox27:SetScript('PostClick',function()vars.guild.bnet=DCLCheckBox27:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox28:SetScript('PostClick',function()vars.group.bnet=DCLCheckBox28:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox29:SetScript('PostClick',function()vars.chart.bnet=DCLCheckBox29:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox30:SetScript('PostClick',function()vars.trade.bnet=DCLCheckBox30:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox31:SetScript('PostClick',function()vars.duel.message=DCLCheckBox31:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox32:SetScript('PostClick',function()vars.pet.message=DCLCheckBox32:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox33:SetScript('PostClick',function()vars.guild.message=DCLCheckBox33:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox34:SetScript('PostClick',function()vars.group.message=DCLCheckBox34:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox35:SetScript('PostClick',function()vars.chart.message=DCLCheckBox35:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox36:SetScript('PostClick',function()vars.trade.message=DCLCheckBox36:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox37:SetScript('PostClick',function()vars.dcl.messages=DCLCheckBox37:GetChecked()DCLUpdate:Print()end)
	DCLCheckBox38:SetScript('PostClick',function()vars.dcl.disable=DCLCheckBox38:GetChecked()DCLUpdate:Print()DCL:BlizzardGT()end)
	DCLUpdate:SetPoint('BOTTOMRIGHT',InterfaceOptionsFrame,-64,64)
	DCLUpdate:SetHeight(8)
	DCLUpdate:SetWidth(8)
	DCLUpdate.text=DCLUpdate:CreateFontString('DCLOptionUpdateAlert','ARTWORK','GameFontNormal')
	DCLUpdate.text:SetPoint('RIGHT',DCLUpdate)
	DCLPanel.okay=function()
		Decliner_SV=DCL:DeepCopy(vars)
		notemp=true
	end
	DCLPanel.cancel=function()
		vars=DCL:DeepCopy(temp)
		notemp=true
		DCLUpdate:Print('|cffff0000'..CANCEL..'')
	end
	DCLPanel.default=function()
		vars=DCL:DeepCopy(defs)
		Decliner_SV=DCL:DeepCopy(defs)
		DCL:SetCheckBoxes()
		DCL:BlizzardGT()
		DCLUpdate:Print()
	end
	DCLPanel.refresh=function()
		DCL:SetCheckBoxes()
		DCL:BlizzardGT()
		if notemp then temp=DCL:DeepCopy(vars) notemp=false end
	end
	SLASH_DECLINER_1='/decliner'
	SLASH_DECLINER_2='/decline'
	SLASH_DECLINER_3='/dcl'
	SlashCmdList['DECLINER_']=function()InterfaceOptionsFrame_OpenToCategory(a)end
end

function DCL:SetCheckBoxes()
	DCLCheckBox01:SetChecked(vars.duel.enabled)
	DCLCheckBox02:SetChecked(vars.pet.enabled)
	DCLCheckBox03:SetChecked(vars.guild.enabled)
	DCLCheckBox04:SetChecked(vars.group.enabled)
	DCLCheckBox05:SetChecked(vars.chart.enabled)
	DCLCheckBox06:SetChecked(vars.trade.enabled)
	DCLCheckBox07:SetChecked(vars.duel.tell)
	DCLCheckBox08:SetChecked(vars.pet.tell)
	DCLCheckBox09:SetChecked(vars.guild.tell)
	DCLCheckBox10:SetChecked(vars.group.tell)
	DCLCheckBox11:SetChecked(vars.chart.tell)
	DCLCheckBox12:SetChecked(vars.trade.tell)
	DCLCheckBox13:SetChecked(vars.duel.guild)
	DCLCheckBox14:SetChecked(vars.pet.guild)
	DCLCheckBox15:SetChecked(false)
	DCLCheckBox16:SetChecked(vars.group.guild)
	DCLCheckBox17:SetChecked(vars.chart.guild)
	DCLCheckBox18:SetChecked(vars.trade.guild)
	DCLCheckBox19:SetChecked(vars.duel.friend)
	DCLCheckBox20:SetChecked(vars.pet.friend)
	DCLCheckBox21:SetChecked(vars.guild.friend)
	DCLCheckBox22:SetChecked(vars.group.friend)
	DCLCheckBox23:SetChecked(vars.chart.friend)
	DCLCheckBox24:SetChecked(vars.trade.friend)
	DCLCheckBox25:SetChecked(vars.duel.bnet)
	DCLCheckBox26:SetChecked(vars.pet.bnet)
	DCLCheckBox27:SetChecked(vars.guild.bnet)
	DCLCheckBox28:SetChecked(vars.group.bnet)
	DCLCheckBox29:SetChecked(vars.chart.bnet)
	DCLCheckBox30:SetChecked(vars.trade.bnet)
	DCLCheckBox31:SetChecked(vars.duel.message)
	DCLCheckBox32:SetChecked(vars.pet.message)
	DCLCheckBox33:SetChecked(vars.guild.message)
	DCLCheckBox34:SetChecked(vars.group.message)
	DCLCheckBox35:SetChecked(vars.chart.message)
	DCLCheckBox36:SetChecked(vars.trade.message)
	DCLCheckBox37:SetChecked(vars.dcl.messages)
	DCLCheckBox38:SetChecked(vars.dcl.disable)
end

local DCLUpdate_OnUpdate=function()
	if (update < GetTime()-1) then
		alpha=DCLUpdate:GetAlpha()
		if (alpha ~= 0) then DCLUpdate:SetAlpha(alpha-.05) end
		if (alpha == 0) then DCLUpdate:SetScript('OnUpdate',nil) end
	end
end

function DCLUpdate:Print(message)
	DCL:MainEventReg()
	if message == nil then message='|cff00ff00'..OKAY..'' end
	DCLUpdate.text:SetText(message)
	DCLUpdate:SetAlpha(1)
	update=GetTime()
	DCLUpdate:SetScript('OnUpdate',DCLUpdate_OnUpdate)
end

-- following function from http://lua-users.org/wiki/CopyTable

function DCL:DeepCopy(orig)
	local orig_type=type(orig)
	local copy
	if orig_type == 'table' then
		copy={}
		for orig_key,orig_value in next,orig,nil do
			copy[DCL:DeepCopy(orig_key)]=DCL:DeepCopy(orig_value)
		end
		setmetatable(copy,DCL:DeepCopy(getmetatable(orig)))
	else -- number,string,boolean,etc
		copy=orig
	end
	return copy
end

--	Decliner: below code pasted from http://www.curse.com/addons/wow/blizzbugssuck
--	Decliner: still broken in 6.2.0.20253

--	Fix InterfaceOptionsFrame_OpenToCategory not actually opening the category (and not even scrolling to it)
--	Confirmed still broken in 6.0.3.19243

function get_panel_name(panel)
	local tp=type(panel)
	local cat=INTERFACEOPTIONS_ADDONCATEGORIES
	if tp == 'string' then
		for i=1,#cat do
			local p=cat[i]
			if p.name == panel then
				if p.parent then
					return get_panel_name(p.parent)
				else
					return panel
				end
			end
		end
	elseif tp == 'table' then
		for i=1,#cat do
			local p=cat[i]
			if p == panel then
				if p.parent then
					return get_panel_name(p.parent)
				else
					return panel.name
				end
			end
		end
	end
end
function InterfaceOptionsFrame_OpenToCategory_Fix(panel)
	if IOF_OTC_F_donotrun or InCombatLockdown() then return end
	local panelName=get_panel_name(panel)
	if not panelName then return end -- if its not part of our list return early
	local noncollapsedHeaders={}
	local shownpanels=0
	local mypanel
	local t={}
	local cat=INTERFACEOPTIONS_ADDONCATEGORIES
	for i=1,#cat do
		local panel=cat[i]
		if not panel.parent or noncollapsedHeaders[panel.parent] then
			if panel.name == panelName then
				panel.collapsed=true
				t.element=panel
				InterfaceOptionsListButton_ToggleSubCategories(t)
				noncollapsedHeaders[panel.name]=true
				mypanel=shownpanels + 1
			end
			if not panel.collapsed then
				noncollapsedHeaders[panel.name]=true
			end
			shownpanels=shownpanels + 1
		end
	end
	local Smin,Smax=InterfaceOptionsFrameAddOnsListScrollBar:GetMinMaxValues()
	if shownpanels > 15 and Smin < Smax then
		local val=(Smax/(shownpanels-15))*(mypanel-2)
		InterfaceOptionsFrameAddOnsListScrollBar:SetValue(val)
	end
	IOF_OTC_F_donotrun=true
	InterfaceOptionsFrame_OpenToCategory(panel)
	IOF_OTC_F_donotrun=false
end
hooksecurefunc('InterfaceOptionsFrame_OpenToCategory',InterfaceOptionsFrame_OpenToCategory_Fix)